-- Test remove_campsite_feature
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'remove_campsite_feature', array['integer']);
select function_lang_is('camper', 'remove_campsite_feature', array['integer'], 'sql');
select function_returns('camper', 'remove_campsite_feature', array['integer'], 'void');
select isnt_definer('camper', 'remove_campsite_feature', array['integer']);
select volatility_is('camper', 'remove_campsite_feature', array['integer'], 'volatile');
select function_privs_are('camper', 'remove_campsite_feature', array['integer'], 'guest', array[]::text[]);
select function_privs_are('camper', 'remove_campsite_feature', array['integer'], 'employee', array[]::text[]);
select function_privs_are('camper', 'remove_campsite_feature', array['integer'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'remove_campsite_feature', array['integer'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_feature_i18n cascade;
truncate campsite_feature cascade;
truncate campsite cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, max_campers, bookable_nights, active)
values (10, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '<p>A</p>', 5, '[1, 7]', true)
;

insert into campsite (campsite_id, company_id, label, campsite_type_id)
values (11, 1, 'A1', 10)
     , (12, 1, 'A2', 10)
;

insert into campsite_feature (campsite_feature_id, campsite_id, icon_name, name)
values (13, 11, 'wifi', 'Feature 1')
     , (14, 11, 'baby', 'Feature 2')
     , (15, 12, 'castle', 'Feature 3')
     , (16, 12, 'ecofriendly', 'Feature 4')
;

insert into campsite_feature_i18n (campsite_feature_id, lang_tag, name)
values (13, 'ca', 'Característica 1')
     , (13, 'es', 'ES 1')
     , (14, 'ca', 'Característica 2')
     , (14, 'es', 'ES 2')
     , (15, 'ca', 'Característica 3')
     , (15, 'es', 'ES 3')
     , (16, 'ca', 'Característica 4')
     , (16, 'es', 'ES 4')
;

select lives_ok(
	$$ select remove_campsite_feature(13) $$,
	'Should be able to delete a feature from the first campsite'
);

select lives_ok(
	$$ select remove_campsite_feature(16) $$,
	'Should be able to delete a feature from the second campsite'
);

select bag_eq(
	$$ select campsite_feature_id, name from campsite_feature $$,
	$$ values (14, 'Feature 2')
	        , (15, 'Feature 3')
	$$,
	'Should have removed the features'
);

select bag_eq(
	$$ select campsite_feature_id, lang_tag, name from campsite_feature_i18n $$,
	$$ values (14, 'ca', 'Característica 2')
	        , (14, 'es', 'ES 2')
	        , (15, 'ca', 'Característica 3')
	        , (15, 'es', 'ES 3')
	$$,
	'Should have removed the features’ translations'
);


select *
from finish();

rollback;
